from functools import lru_cache
import heapq

class FuzzyMatcher:
    def __init__(self):
        uso_obra_enum = {
        	"CH731": "ARQUITETURA",
        	"CH731.18": "EDIFÍCIOS",
        	"CH731.18.1": "EDIFÍCIOS PARA ASSISTÊNCIA SOCIAL",
        	"CH731.18.2": "EDIFÍCIOS DE SAÚDE",
        	"CH731.18.3": "EDIFÍCIOS INDUSTRIAIS",
        	"CH731.18.4": "EDIFÍCIOS COMERCIAIS",
        	"CH731.18.5": "EDIFÍCIOS PÚBLICOS",
        	"CH731.18.6": "EDIFÍCIOS PARA COMUNICAÇÕES",
        	"CH 731.18.7": "EDIFÍCIOS PARA TRANSPORTES",
        	"CH731.18.8": "EDIFÍCIOS PARA CORREIÇÃO",
        	"CH731.18.9": "EDIFÍCIOS PARA EDUCAÇÃO E CULTURA",
        	"CH731.18.10": "EDIFÍCIOS RELIGIOSOS",
        	"CH731.18.11": "EDIFÍCIOS PARA RECREAÇÃO",
        	"CH731.18.12": "EDIFÍCIOS RESIDENCIAIS",
        	"CH731.18.13": "EDIFÍCIOS PARA PESQUISA",
        	"CH731.18.14": "EDIFÍCIOS DE USO MÚLTIPLO",
        	"CH731.18.15": "EDIFÍCIOS SUSTENTÁVEIS",
        	"CH731.18.16": "EDIFÍCIOS ADMINISTRATIVOS",
        	"CH731.18.1.1": "ALBERGUES NOTURNOS",
        	"CH731.18.1.2": "INSTITUIÇÕES DE LONGA PERMANÊNCIA PARA IDOSOS",
        	"CH731.18.1.3": "CRECHES",
        	"CH731.18.1.4": "ORFANATOS",
        	"CH731.18.2.1": "AMBULATÓRIOS",
        	"CH731.18.2.2": "CENTROS DE REABILITAÇÃO (ARQUITETURA)",
        	"CH731.18.2.3": "CENTROS DE SAÚDE (ARQUITETURA)",
        	"CH731.18.2.4": "CLÍNICAS",
        	"CH731.18.2.5": "CONSULTÓRIOS",
        	"CH731.18.2.6": "HOSPITAIS (ARQUITETURA)",
        	"CH731.18.2.7": "HOSPITAIS INFANTIS (ARQUITETURA)",
        	"CH731.18.2.8": "HOSPITAIS PSIQUIÁTRICOS (ARQUITETURA)",
        	"CH731.18.2.9": "HOSPITAIS VETERINÁRIOS (ARQUITETURA)",
        	"CH731.18.2.10": "MATERNIDADES",
        	"CH731.18.3.1": "INDÚSTRIAS (ARQUITETURA)",
        	"CH731.18.4.1": "ARMAZÉNS",
        	"CH731.18.4.2": "GARAGENS COMERCIAIS",
        	"CH731.18.4.3": "LOJAS",
        	"CH731.18.4.4": "EDITORAS (ARQUITETURA)",
        	"CH731.18.4.5": "MERCADOS",
        	"CH731.18.4.6": "PADARIAS",
        	"CH731.18.4.7": "POSTOS DE COMBUSTÍVEIS",
        	"CH731.18.4.8": "SHOPPING CENTERS",
        	"CH731.18.4.9": "SUPERMERCADOS",
        	"CH731.18.4.10": "OFICINAS",
        	"CH731.18.4.11": "EDIFÍCIOS DE ESCRITÓRIOS",
        	"CH731.18.5.1": "EDIFÍCIOS LEGISLATIVOS",
        	"CH731.18.5.2": "EDIFÍCIOS EXECUTIVOS",
        	"CH731.18.5.3": "EDIFÍCIOS JUDICIÁRIOS",
        	"CH731.18.5.4": "EDIFÍCIOS MILITARES",
        	"CH731.18.6.1": "CENTRAL TELEFÔNICA",
        	"CH731.18.6.2": "CORREIOS E TELÉGRAFOS",
        	"CH731.18.6.3": "GRÁFICAS",
        	"CH731.18.7.1": "ESTAÇÕES FERROVIÁRIAS",
        	"CH731.18.7.2": "ESTAÇÕES METROVIÁRIAS",
        	"CH731.18.7.3": "ESTAÇÕES RODOVIÁRIAS",
        	"CH731.18.8.1": "PRISÕES",
        	"CH731.18.9.1": "BIBLIOTECAS (ARQUITETURA)",
        	"CH731.18.9.2": "MUSEUS (ARQUITETURA)",
        	"CH731.18.9.3": "ESCOLAS (ARQUITETURA)",
        	"CH731.18.9.4": "UNIVERSIDADES (ARQUITETURA)",
        	"CH731.18.10.1": "ABADIAS",
        	"CH731.18.10.2": "CENTROS ESPÍRITAS",
        	"CH731.18.10.3": "CONVENTOS",
        	"CH731.18.10.4": "IGREJAS (ARQUITETURA)",
        	"CH731.18.10.5": "SINAGOGAS",
        	"CH731.18.10.6": "TEMPLOS",
        	"CH731.18.10.7": "TERREIROS",
        	"CH731.18.10.8": "MESQUITAS",
        	"CH731.18.10.9": "MOSTEIROS",
        	"CH731.18.10.10": "SANTUÁRIOS",
        	"CH731.18.11.1": "AUDITÓRIOS",
        	"CH731.18.11.2": "BARES",
        	"CH731.18.11.3": "CENTROS COMUNITÁRIOS",
        	"CH731.18.11.4": "CENTROS CULTURAIS",
        	"CH731.18.11.5": "CENTROS DE CONVENÇÕES",
        	"CH731.18.11.6": "CINEMAS (ARQUITETURA)",
        	"CH731.18.11.7": "CIRCOS",
        	"CH731.18.11.8": "CAFETERIAS",
        	"CH731.18.11.9": "CONSTRUÇÕES ESPORTIVAS",
        	"CH731.18.11.10": "ESTAÇÕES DE ÁGUA",
        	"CH731.18.11.11": "PARQUES DE DIVERSÕES",
        	"CH731.18.11.12": "PARQUES INFANTIS",
        	"CH731.18.11.13": "PAVILHÕES PARA EXPOSIÇÕES",
        	"CH731.18.11.14": "RESTAURANTES",
        	"CH731.18.11.15": "SAUNAS",
        	"CH731.18.11.16": "TEATROS (ARQUITETURA)",
        	"CH731.18.11.17": "BOATES",
        	"CH731.18.11.18": "CASAS NOTURNAS",
        	"CH731.18.12.1": "EDIFÍCIOS RESIDENCIAIS (TIPOLOGIA)",
        	"CH731.18.12.1.1": "ALOJAMENTOS",
        	"CH731.18.12.1.2": "APARTAMENTOS",
        	"CH731.18.12.1.3": "FLATS",
        	"CH731.18.12.1.4": "HOTÉIS",
        	"CH731.18.12.1.5": "LOFTS",
        	"CH731.18.12.1.6": "MOTEIS",
        	"CH731.18.12.1.7": "CASAS",
        	"CH731.18.12.1.8": "CASAS HISTÓRICAS",
        	"CH731.18.12.1.9": "CASAS SUBTERRÂNEAS",
        	"CH731.18.12.1.10": "CASAS TROGLODITAS",
        	"CH731.18.12.1.11": "CASA MÓVEL",
        	"CH731.18.12.1.12": "CASA-REBOQUE",
        	"CH731.18.12.1.13": "CHALÉS",
        	"CH731.18.12.1.14": "CASTELOS",
        	"CH731.18.12.1.15": "CONJUNTOS RESIDENCIAIS",
        	"CH731.18.12.1.16": "MANSÕES",
        	"CH731.18.12.1.17": "PALÁCIOS",
        	"CH731.18.12.1.18": "VILAS",
        	"CH731.18.12.4": "EDIFÍCIOS RESIDENCIAIS (FUNÇÃO)",
        	"CH731.18.12.4.1": "CASAS A PROVA DE BOMBA",
        	"CH731.18.12.4.2": "CASAS ANTISSÍSMICAS",
        	"CH731.18.12.4.3": "CASAS DE EMERGÊNCIA",
        	"CH731.18.12.4.4": "CASAS DE FÉRIAS",
        	"CH731.18.12.4.5": "CASAS DE CAMPO",
        	"CH731.18.12.4.6": "CASAS DE PRAIA",
        	"CH731.18.13.1": "LABORATÓRIOS",
        	"CH731.18.14": "EDIFÍCIOS DE USO MÚLTIPLO",
        	"CH731.18.15": "EDIFÍCIOS SUSTENTÁVEIS",
        	"CH731.18.16": "EDIFÍCIOS ADMINISTRATIVOS"
        }
        uso_obra_enum = {value: key for key, value in uso_obra_enum.items()}

        endereco_tipo_enum = {
            'TRAVESSA': 'TRAVESSA',
            'ACESSO': 'ACESSO',
            'ALAMEDA': 'ALAMEDA',
            'AVENIDA': 'AVENIDA',
            'BECO': 'BECO',
            'CAMINHO': 'CAMINHO',
            'COMPLEXO_VIARIO': 'COMPLEXO_VIARIO',
            'ESPLANADA': 'ESPLANADA',
            'ESTRADA': 'ESTRADA',
            'GALERIA': 'GALERIA',
            'JARDIM': 'JARDIM',
            'LADEIRA': 'LADEIRA',
            'LARGO': 'LARGO',
            'PARQUE': 'PARQUE',
            'PASSAGEM': 'PASSAGEM',
            'PASSARELA': 'PASSARELA',
            'PATIO': 'PATIO',
            'PONTE': 'PONTE',
            'PRAÇA': 'PRAÇA',
            'RODOVIA': 'RODOVIA',
            'RUA': 'RUA',
            'SERVIDÃO': 'SERVIDÃO',
            'TUNEL': 'TUNEL',
            'VEREDA': 'VEREDA',
            'VIAS': 'VIAS',
            'VILA': 'VILA',
        }

        endereco_titulo_enum = {
            'ABADE': 'ABADE',
            'ACADEMICO': 'ACADEMICO',
            'ADVOGADO': 'ADVOGADO',
            'AGENTE': 'AGENTE',
            'AGRICULTOR': 'AGRICULTOR',
            'AGRIMENSOR': 'AGRIMENSOR',
            'AJUDANTE': 'AJUDANTE',
            'ALFERES': 'ALFERES',
            'ALMIRANTE': 'ALMIRANTE',
            'APOSTOLO': 'APOSTOLO',
            'ARCANJO': 'ARCANJO',
            'ARCEBISPO': 'ARCEBISPO',
            'ARCIPRESTE': 'ARCIPRESTE',
            'ARQUITETA': 'ARQUITETA',
            'ARQUITETO': 'ARQUITETO',
            'ARQUITETO_PROFESSOR': 'ARQUITETO_PROFESSOR',
            'ASPIRANTE': 'ASPIRANTE',
            'AVENIDA': 'AVENIDA',
            'AVIADOR': 'AVIADOR',
            'AVIADORA': 'AVIADORA',
            'BACHAREL': 'BACHAREL',
            'BANDEIRANTE': 'BANDEIRANTE',
            'BANQUEIRO': 'BANQUEIRO',
            'BARAO': 'BARAO',
            'BARONESA': 'BARONESA',
            'BEATO': 'BEATO',
            'BEATO_PADRE': 'BEATO_PADRE',
            'BEM_AVENTURADO': 'BEM_AVENTURADO',
            'BENEMERITO': 'BENEMERITO',
            'BISPO': 'BISPO',
            'BRIGADEIRO': 'BRIGADEIRO',
            'CABO': 'CABO',
            'CABO_PM': 'CABO_PM',
            'CADETE': 'CADETE',
            'CAMPEADOR': 'CAMPEADOR',
            'CAPITAO': 'CAPITAO',
            'CAPITAO_ALMIRANTE': 'CAPITAO_ALMIRANTE',
            'CAPITAO_DE_FRAGATA': 'CAPITAO_DE_FRAGATA',
            'CAPITAO_DE_MAR_E_GUERRA': 'CAPITAO_DE_MAR_E_GUERRA',
            'CAPITAO_GENERAL': 'CAPITAO_GENERAL',
            'CAPITAO_MOR': 'CAPITAO_MOR',
            'CAPITAO_PM': 'CAPITAO_PM',
            'CAPITAO_TENENTE': 'CAPITAO_TENENTE',
            'CARDEAL': 'CARDEAL',
            'CARTEIRO': 'CARTEIRO',
            'CATEQUISTA': 'CATEQUISTA',
            'CAVALEIRO': 'CAVALEIRO',
            'CAVALHEIRO': 'CAVALHEIRO',
            'CINEASTA': 'CINEASTA',
            'COMANDANTE': 'COMANDANTE',
            'COMEDIANTE': 'COMEDIANTE',
            'COMENDADOR': 'COMENDADOR',
            'COMENDADORA': 'COMENDADORA',
            'COMENDADORA_PROFESSORA': 'COMENDADORA_PROFESSORA',
            'COMISSARIA': 'COMISSARIA',
            'COMISSARIO': 'COMISSARIO',
            'COMPOSITOR': 'COMPOSITOR',
            'CONDE': 'CONDE',
            'CONDESSA': 'CONDESSA',
            'CONEGO': 'CONEGO',
            'CONFRADE': 'CONFRADE',
            'CONSELHEIRO': 'CONSELHEIRO',
            'CONSUL': 'CONSUL',
            'CORONEL': 'CORONEL',
            'CORONEL_PM': 'CORONEL_PM',
            'CORREGEDOR': 'CORREGEDOR',
            'DELEGADO': 'DELEGADO',
            'DENTISTA': 'DENTISTA',
            'DEPUTADA': 'DEPUTADA',
            'DEPUTADO': 'DEPUTADO',
            'DEPUTADO_DOUTOR': 'DEPUTADO_DOUTOR',
            'DESEMBARGADOR': 'DESEMBARGADOR',
            'DIACONO': 'DIACONO',
            'DOM': 'DOM',
            'DONA': 'DONA',
            'DOUTOR': 'DOUTOR',
            'DOUTORA': 'DOUTORA',
            'DUQUE': 'DUQUE',
            'DUQUESA': 'DUQUESA',
            'EDITOR': 'EDITOR',
            'EDUCADOR': 'EDUCADOR',
            'EDUCADORA': 'EDUCADORA',
            'EMBAIXADOR': 'EMBAIXADOR',
            'EMBAIXADORA': 'EMBAIXADORA',
            'EMPRESARIO': 'EMPRESARIO',
            'ENGENHEIRO': 'ENGENHEIRO',
            'ENGENHEIRA': 'ENGENHEIRA',
            'ESCOTEIRO': 'ESCOTEIRO',
            'ESCRITOR': 'ESCRITOR',
            'EXPEDICIONARIO': 'EXPEDICIONARIO',
            'FISICO': 'FISICO',
            'FREI': 'FREI',
            'GENERAL': 'GENERAL',
            'GOVERNADOR': 'GOVERNADOR',
            'GRUMETE': 'GRUMETE',
            'GUARDA_CIVIL_METROPOLITANO': 'GUARDA_CIVIL_METROPOLITANO',
            'IMACULADA': 'IMACULADA',
            'IMPERATRIZ': 'IMPERATRIZ',
            'INFANTE': 'INFANTE',
            'INSPETOR': 'INSPETOR',
            'IRMA': 'IRMA',
            'IRMAO': 'IRMAO',
            'IRMAOS': 'IRMAOS',
            'IRMAS': 'IRMAS',
            'JORNALISTA': 'JORNALISTA',
            'LIBERTADOR': 'LIBERTADOR',
            'LIDER_COMUNITARIO': 'LIDER_COMUNITARIO',
            'LIVREIRO': 'LIVREIRO',
            'LORDE': 'LORDE',
            'MADAME': 'MADAME',
            'MADRE': 'MADRE',
            'MAESTRO': 'MAESTRO',
            'MAJOR': 'MAJOR',
            'MAJOR_AVIADOR': 'MAJOR_AVIADOR',
            'MAJOR_BRIGADEIRO': 'MAJOR_BRIGADEIRO',
            'MAQUINISTA': 'MAQUINISTA',
            'MARECHAL': 'MARECHAL',
            'MARECHAL_DO_AR': 'MARECHAL_DO_AR',
            'MARQUES': 'MARQUES',
            'MARQUESA': 'MARQUESA',
            'MERE': 'MERE',
            'MESTRAS': 'MESTRAS',
            'MESTRE': 'MESTRE',
            'MESTRES': 'MESTRES',
            'MILITANTE': 'MILITANTE',
            'MINISTRO': 'MINISTRO',
            'MISSIONARIA': 'MISSIONARIA',
            'MISSIONARIO': 'MISSIONARIO',
            'MONGE': 'MONGE',
            'MONSENHOR': 'MONSENHOR',
            'MUNICIPAL': 'MUNICIPAL',
            'MUSICO': 'MUSICO',
            'NOSSA_SENHORA': 'NOSSA_SENHORA',
            'NOSSO_SENHOR': 'NOSSO_SENHOR',
            'OUVIDOR': 'OUVIDOR',
            'PADRE': 'PADRE',
            'PADRES': 'PADRES',
            'PAI': 'PAI',
            'PAPA': 'PAPA',
            'PASTOR': 'PASTOR',
            'PASTORA': 'PASTORA',
            'PATRIARCA': 'PATRIARCA',
            'POETA': 'POETA',
            'POETISA': 'POETISA',
            'PREFEITO': 'PREFEITO',
            'PRESIDENTE': 'PRESIDENTE',
            'PRESIDENTE_DA_ACADEMIA_BRASILEIRA_DE_LETRAS': 'PRESIDENTE_DA_ACADEMIA_BRASILEIRA_DE_LETRAS',
            'PRESIDENTE_VEREADOR': 'PRESIDENTE_VEREADOR',
            'PRIMEIRO_SARGENTO': 'PRIMEIRO_SARGENTO',
            'PRIMEIRO_SARGENTO_PM': 'PRIMEIRO_SARGENTO_PM',
            'PRIMEIRO_TENENTE': 'PRIMEIRO_TENENTE',
            'PRIMEIRO_TENENTE_PM': 'PRIMEIRO_TENENTE_PM',
            'PRINCESA': 'PRINCESA',
            'PRINCIPE': 'PRINCIPE',
            'PROCURADOR': 'PROCURADOR',
            'PROFESSOR': 'PROFESSOR',
            'PROFESSOR_DOUTOR': 'PROFESSOR_DOUTOR',
            'PROFESSOR_ENGENHEIRO': 'PROFESSOR_ENGENHEIRO',
            'PROFESSORA': 'PROFESSORA',
            'PROFETA': 'PROFETA',
            'PROMOTOR': 'PROMOTOR',
            'PROVEDOR': 'PROVEDOR',
            'PROVEDOR_MOR': 'PROVEDOR_MOR',
            'RABINO': 'RABINO',
            'RADIALISTA': 'RADIALISTA',
            'RAINHA': 'RAINHA',
            'REGENTE': 'REGENTE',
            'REI': 'REI',
            'REVERENDO': 'REVERENDO',
            'RUA': 'RUA',
            'SACERDOTE': 'SACERDOTE',
            'SANTA': 'SANTA',
            'SANTO': 'SANTO',
            'SAO': 'SAO',
            'SARGENTO': 'SARGENTO',
            'SARGENTO_MOR': 'SARGENTO_MOR',
            'SARGENTO_PM': 'SARGENTO_PM',
            'SEGUNDO_SARGENTO': 'SEGUNDO_SARGENTO',
            'SEGUNDO_SARGENTO_PM': 'SEGUNDO_SARGENTO_PM',
            'SEGUNDO_TENENTE': 'SEGUNDO_TENENTE',
            'SENADOR': 'SENADOR',
            'SENHOR': 'SENHOR',
            'SENHORA': 'SENHORA',
            'SERTANISTA': 'SERTANISTA',
            'SEU': 'SEU',
            'SINHA': 'SINHA',
            'SIR': 'SIR',
            'SOCIOLOGO': 'SOCIOLOGO',
            'SOLDADO': 'SOLDADO',
            'SOLDADO_PM': 'SOLDADO_PM',
            'SEROR': 'SEROR',
            'SUB_TENENTE': 'SUB_TENENTE',
            'TENENTE': 'TENENTE',
            'TENENTE_AVIADOR': 'TENENTE_AVIADOR',
            'TENENTE_BRIGADEIRO': 'TENENTE_BRIGADEIRO',
            'TENENTE_CORONEL': 'TENENTE_CORONEL',
            'TEOLOGO': 'TEOLOGO',
            'TERCEIRO_SARGENTO': 'TERCEIRO_SARGENTO',
            'TERCEIRO_SARGENTO_PM': 'TERCEIRO_SARGENTO_PM',
            'TIA': 'TIA',
            'VEREADOR': 'VEREADOR',
            'VICE_ALMIRANTE': 'VICE_ALMIRANTE',
            'VICE_REI': 'VICE_REI',
            'VIGARIO': 'VIGARIO',
            'VISCONDE': 'VISCONDE',
            'VISCONDESSA': 'VISCONDESSA',
            'VOLUNTARIO': 'VOLUNTARIO',
            'VOLUNTARIOS': 'VOLUNTARIOS',
        }

        obra_status_enum = {
            'RESTAURADO': 'RESTAURADO',
            'REFORMADO': 'REFORMADO',
            'DEMOLIDO': 'DEMOLIDO',
            'CONSTRUIDO':'CONSTRUIDO'
        }


        self.matchers = {
            'uso_obra': (uso_obra_enum, list(uso_obra_enum.keys())),
            'endereco_tipo': (endereco_tipo_enum, list(endereco_tipo_enum.keys())),
            'endereco_titulo': (endereco_titulo_enum, list(endereco_titulo_enum.keys())),
            'obra_status': (obra_status_enum, list(obra_status_enum.keys()))
        }
        self.enum = None
        self.choices = None


    def match(self, query, enum_name: str):
        self.enum, self.choices = self.matchers[enum_name]
        if query not in self.enum:
            return self.enum[self.fuzzy_match_levenshtein(query)]
        return self.enum[query]

    def fuzzy_match_levenshtein(self, query):
        heap = []
        if self.choices is None:
            return None
        for choice in self.choices:
            heapq.heappush(heap, (self.levenshtein_distance(query, choice), choice))

        closest_distance, closest_choice = heapq.heappop(heap)

        return closest_choice

    @lru_cache(maxsize=2048)
    def levenshtein_distance(self, s1, s2):

        # Base cases
        if len(s1) == 0:
            return len(s2)
        if len(s2) == 0:
            return len(s1)

        # Initialize the matrix
        matrix = [[0] * (len(s2) + 1) for _ in range(len(s1) + 1)]
        for i in range(len(s1) + 1):
            matrix[i][0] = i
        for j in range(len(s2) + 1):
            matrix[0][j] = j

        # Calculate distances
        for i in range(1, len(s1) + 1):
            for j in range(1, len(s2) + 1):
                cost = 0 if s1[i - 1] == s2[j - 1] else 1
                matrix[i][j] = min(
                    matrix[i - 1][j] + 1,  # Deletion
                    matrix[i][j - 1] + 1,  # Insertion
                    matrix[i - 1][j - 1] + cost  # Substitution
                )

        return matrix[len(s1)][len(s2)]
